package blusunrize.immersiveengineering.client.fx;

import blusunrize.immersiveengineering.common.util.Utils;
import com.google.common.collect.ArrayListMultimap;
import net.minecraft.client.particle.Particle;
import net.minecraft.client.renderer.BufferBuilder;
import net.minecraft.entity.Entity;
import net.minecraft.util.ResourceLocation;
import net.minecraft.world.World;

public abstract class EntityFXIEBase extends Particle
{
	public static ArrayListMultimap<String, EntityFXIEBase> queuedRenders = ArrayListMultimap.create();
	public static ArrayListMultimap<String, EntityFXIEBase> queuedDepthIgnoringRenders = ArrayListMultimap.create();

	protected float partialTicks;
	protected float f3;
	protected float f4;
	protected float f5;
	protected float f6;
	protected float f7;
	protected static ResourceLocation vanillaParticleTextures = new ResourceLocation("textures/particle/particles.png");

	public EntityFXIEBase(World world, double x,double y,double z, double mx,double my,double mz)
	{
		super(world, x,y,z, mx,my,mz);
		this.field_70547_e = 16;
		this.field_187126_f = x;
		this.field_187127_g = y;
		this.field_187128_h = z;
		this.field_187129_i = mx;
		this.field_187130_j = my;
		this.field_187131_k = mz;
		this.func_70536_a(Utils.RAND.nextInt(3));
	}

	@Override
	public void func_180434_a(BufferBuilder worldRendererIn, Entity entityIn, float partialTicks, float f3, float f4, float f5, float f6, float f7)
	{
		this.partialTicks=partialTicks;
		this.f3=f3;
		this.f4=f4;
		this.f5=f5;
		this.f6=f6;
		this.f7=f7;
		this.addToQueue(false);
	}

	public void addToQueue(boolean ignoreDepth)
	{
		if(!ignoreDepth)
			queuedRenders.put(getParticleName(), this);
		else
			queuedDepthIgnoringRenders.put(getParticleName(), this);
	}

	public abstract String getParticleName();
	public ResourceLocation getParticleTexture()
	{
		return vanillaParticleTextures;
	}
	public void tessellateFromQueue(BufferBuilder worldRendererIn)
	{
		float f6 = (float)this.field_94054_b / 16.0F;
		float f7 = f6 + 0.0624375F;
		float f8 = (float)this.field_94055_c / 16.0F;
		float f9 = f8 + 0.0624375F;
		float f10 = 0.1F * this.field_70544_f;

		if (this.field_187119_C != null)
		{
			f6 = this.field_187119_C.func_94209_e();
			f7 = this.field_187119_C.func_94212_f();
			f8 = this.field_187119_C.func_94206_g();
			f9 = this.field_187119_C.func_94210_h();
		}

		float f11 = (float)(this.field_187123_c + (this.field_187126_f - this.field_187123_c) * (double)partialTicks - field_70556_an);
		float f12 = (float)(this.field_187124_d + (this.field_187127_g - this.field_187124_d) * (double)partialTicks - field_70554_ao);
		float f13 = (float)(this.field_187125_e + (this.field_187128_h - this.field_187125_e) * (double)partialTicks - field_70555_ap);

		int i = this.func_189214_a(partialTicks);
		int j = i >> 16 & 65535;
		int k = i & 65535;
		worldRendererIn.func_181662_b((f11 - f3 * f10 - f6 * f10), (f12 - f4 * f10), (f13 - f5 * f10 - f7 * f10)).func_187315_a(f7,f9).func_181666_a(this.field_70552_h, this.field_70553_i, this.field_70551_j, this.field_82339_as).func_187314_a(j, k).func_181675_d();
		worldRendererIn.func_181662_b((f11 - f3 * f10 + f6 * f10), (f12 + f4 * f10), (f13 - f5 * f10 + f7 * f10)).func_187315_a(f7,f8).func_181666_a(this.field_70552_h, this.field_70553_i, this.field_70551_j, this.field_82339_as).func_187314_a(j, k).func_181675_d();
		worldRendererIn.func_181662_b((f11 + f3 * f10 + f6 * f10), (f12 + f4 * f10), (f13 + f5 * f10 + f7 * f10)).func_187315_a(f6,f8).func_181666_a(this.field_70552_h, this.field_70553_i, this.field_70551_j, this.field_82339_as).func_187314_a(j, k).func_181675_d();
		worldRendererIn.func_181662_b((f11 + f3 * f10 - f6 * f10), (f12 - f4 * f10), (f13 + f5 * f10 - f7 * f10)).func_187315_a(f6,f9).func_181666_a(this.field_70552_h, this.field_70553_i, this.field_70551_j, this.field_82339_as).func_187314_a(j, k).func_181675_d();
	}
}
